express    = require('express')
app        = express()
bodyParser = require('body-parser')
cors = require('cors')

User = requireUser = require './model/User'
UserList = require './model/UserList'
Money = require './model/Money'
MoneyList = require './model/MoneyList'

app.use bodyParser.urlencoded { extended: true }
app.use bodyParser.json()

port = process.env.PORT || 8080
router = express.Router()

users = new UserList()
moneyList = new MoneyList()


router.use (req, res, next) ->
    #do logging
    ## --- console.log('Receive request:', req);
    next() #make sure we go to the next routes and don't stop here

app.use cors()

app.use (req, res, next) ->
    res.header "Access-Control-Allow-Credentials", "true"
    res.header "Access-Control-Allow-Origin", "*"
    res.header "Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept, Content-length"
    res.header "Access-Control-Allow-Methods", "GET, POST, PUT, DELETE"
    next()


# moneyList.addMoney {
#         "amount": 12345678,
#         "description": "TEST",
#         "spending": "true",
#         "date": "2015-12-11T17:30:00.000Z",
#         "userId": 1
#     }

router.get '/', (req, res) ->
    res.json { message: 'hooray! welcome to our api!' }

router.route('/test')
    .get (req, res) ->
        # --- console.log "GET /test", req.body, req.query, req.params
        res.status(200).json({responese: "OK"})
    .post (req, res) ->
        # --- console.log "POST /test", req.body, req.query, req.params
        res.status(201).json({responese: "OK"})
    .put (req, res) ->
        # --- console.log "PUT /test", req.body, req.query, req.params
        res.status(200).json({responese: "OK"})
    .delete (req, res) ->
        # --- console.log "DELETE /test", req.body, req.query, req.params
        res.status(200).json({responese: "OK"})

router.route('/users')
    .post (req, res) ->
        newUser = users.addUser req.body
        if newUser is false
            res.status(400).json { message: 'Error: User wasn\'t created!' }
        else
            # --- console.log "Added new user", newUser.name, newUser.lastname
            res.status(201).json newUser
            
    .put (req, res) ->
        # --- console.log "PUT /users", "ID="+req.body.id_user
        usr = users.findById parseInt(req.body.id_user)
        for key,value of req.body
            usr[key] = value
        # --- console.log "Updated user", usr
        res.status(200).json()

    .get (req, res) ->
        users.getMoney moneyList
        fullUserList = users.getAllUsers()
        # --- console.log "GET users/ query", req.query
        if req.query.gender
            fullUserList = fullUserList.filter (item) ->
                item.gender is req.query.gender
        if req.query.count
            fullUserList = fullUserList.slice 0, Math.min fullUserList.length, parseInt(req.query.count)
        if req.query.spending
            for user in fullUserList
                user.money = user.money.filter (item) ->
                    item.spending is req.query.spending
        res.json fullUserList


router.route('/users/:user_id')
    .get (req, res) ->
        # --- console.log "GET users/:user_id query", req.query
        usr = users.findById req.params.user_id
        if !req.query.money or req.query.money isnt 'true'
            # --- console.log "Odstranuji penize"
            usr.money = null
        if usr is false then res.status(404).json() else res.json usr

    .delete (req, res) ->
        # --- console.log "DELETE /users/"+req.params.user_id
        tmpUser = users.findById req.params.user_id
        if !tmpUser
            res.status(404).json()
        removed = users.removeUser tmpUser
        res.status(200).json()

router.route('/money')
    .post (req, res) ->
        newMoney = moneyList.addMoney req.body
        if newMoney is false
            res.status(400).json { message: 'Error: Money wasn\'t created!' }
        else
            # --- console.log "Added new money", newMoney.name, newMoney.lastname
            res.status(201).json newMoney

    .put (req, res) ->
        # --- console.log "PUT /money"
        res.status(200).json()

    .get (req, res) ->
        fullMoneyList = moneyList.getAllMoney()
        # --- console.log "GET money/ query", req.query
        if req.query.userId
            fullMoneyList = fullMoneyList.filter (item) ->
                item.userId is parseInt req.query.userId
        if req.query.lessThan
            fullMoneyList = fullMoneyList.filter (item) ->
                item.amount < parseInt(req.query.lessThan)
        if req.query.moreThan
            fullMoneyList = fullMoneyList.filter (item) ->
                item.amount > parseInt(req.query.moreThan)
        if req.query.count
            fullMoneyList = fullMoneyList.slice 0, Math.min fullMoneyList.length, parseInt(req.query.count)
        if req.query.spending
            for user in fullMoneyList
                user.money = user.money.filter (item) ->
                    item.spending is req.query.spending
        res.json fullMoneyList

router.route('/money/:money_id')
    .get (req, res) ->
        # --- console.log "GET money/:money_id query", req.query
        usr = moneyList.findById req.params.money_id
        if usr is false then res.status(404).json() else res.json usr

    .delete (req, res) ->
        # --- console.log "DELETE /money/"+req.params.money_id
        tmpMoney = moneyList.findById req.params.money_id
        if !tmpMoney
            res.status(404).json()
        removed = moneyList.removeMoney tmpMoney
        res.status(200).json()


app.use '/api', router

app.listen port
console.log 'Server running on port ' + port