// Generated by CoffeeScript 1.9.3
(function() {
  var Money, MoneyList, User, UserList, app, bodyParser, cors, express, moneyList, port, requireUser, router, users;

  express = require('express');

  app = express();

  bodyParser = require('body-parser');

  cors = require('cors');

  User = requireUser = require('./model/User');

  UserList = require('./model/UserList');

  Money = require('./model/Money');

  MoneyList = require('./model/MoneyList');

  app.use(bodyParser.urlencoded({
    extended: true
  }));

  app.use(bodyParser.json());

  port = process.env.PORT || 8080;

  router = express.Router();

  users = new UserList();

  moneyList = new MoneyList();

  router.use(function(req, res, next) {
    return next();
  });

  app.use(cors());

  app.use(function(req, res, next) {
    res.header("Access-Control-Allow-Credentials", "true");
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept, Content-length");
    res.header("Access-Control-Allow-Methods", "GET, POST, PUT, DELETE");
    return next();
  });

  router.get('/', function(req, res) {
    return res.json({
      message: 'hooray! welcome to our api!'
    });
  });

  router.route('/test').get(function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  }).post(function(req, res) {
    return res.status(201).json({
      responese: "OK"
    });
  }).put(function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  })["delete"](function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  });

  router.route('/users').post(function(req, res) {
    var newUser;
    newUser = users.addUser(req.body);
    if (newUser === false) {
      return res.status(400).json({
        message: 'Error: User wasn\'t created!'
      });
    } else {
      return res.status(201).json(newUser);
    }
  }).put(function(req, res) {
    var key, ref, usr, value;
    usr = users.findById(parseInt(req.body.id_user));
    ref = req.body;
    for (key in ref) {
      value = ref[key];
      usr[key] = value;
    }
    return res.status(200).json();
  }).get(function(req, res) {
    var fullUserList, i, len, user;
    users.getMoney(moneyList);
    fullUserList = users.getAllUsers();
    if (req.query.gender) {
      fullUserList = fullUserList.filter(function(item) {
        return item.gender === req.query.gender;
      });
    }
    if (req.query.count) {
      fullUserList = fullUserList.slice(0, Math.min(fullUserList.length, parseInt(req.query.count)));
    }
    if (req.query.spending) {
      for (i = 0, len = fullUserList.length; i < len; i++) {
        user = fullUserList[i];
        user.money = user.money.filter(function(item) {
          return item.spending === req.query.spending;
        });
      }
    }
    return res.json(fullUserList);
  });

  router.route('/users/:user_id').get(function(req, res) {
    var usr;
    usr = users.findById(req.params.user_id);
    if (!req.query.money || req.query.money !== 'true') {
      usr.money = null;
    }
    if (usr === false) {
      return res.status(404).json();
    } else {
      return res.json(usr);
    }
  })["delete"](function(req, res) {
    var removed, tmpUser;
    tmpUser = users.findById(req.params.user_id);
    if (!tmpUser) {
      res.status(404).json();
    }
    removed = users.removeUser(tmpUser);
    return res.status(200).json();
  });

  router.route('/money').post(function(req, res) {
    var newMoney;
    newMoney = moneyList.addMoney(req.body);
    if (newMoney === false) {
      return res.status(400).json({
        message: 'Error: Money wasn\'t created!'
      });
    } else {
      return res.status(201).json(newMoney);
    }
  }).put(function(req, res) {
    return res.status(200).json();
  }).get(function(req, res) {
    var fullMoneyList, i, len, user;
    fullMoneyList = moneyList.getAllMoney();
    if (req.query.userId) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.userId === parseInt(req.query.userId);
      });
    }
    if (req.query.lessThan) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.amount < parseInt(req.query.lessThan);
      });
    }
    if (req.query.moreThan) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.amount > parseInt(req.query.moreThan);
      });
    }
    if (req.query.count) {
      fullMoneyList = fullMoneyList.slice(0, Math.min(fullMoneyList.length, parseInt(req.query.count)));
    }
    if (req.query.spending) {
      for (i = 0, len = fullMoneyList.length; i < len; i++) {
        user = fullMoneyList[i];
        user.money = user.money.filter(function(item) {
          return item.spending === req.query.spending;
        });
      }
    }
    return res.json(fullMoneyList);
  });

  router.route('/money/:money_id').get(function(req, res) {
    var usr;
    usr = moneyList.findById(req.params.money_id);
    if (usr === false) {
      return res.status(404).json();
    } else {
      return res.json(usr);
    }
  })["delete"](function(req, res) {
    var removed, tmpMoney;
    tmpMoney = moneyList.findById(req.params.money_id);
    if (!tmpMoney) {
      res.status(404).json();
    }
    removed = moneyList.removeMoney(tmpMoney);
    return res.status(200).json();
  });

  app.use('/api', router);

  app.listen(port);

}).call(this);
