// Generated by CoffeeScript 1.9.3
(function() {
  var Money, MoneyList;

  Money = require("./Money");

  MoneyList = (function() {
    function MoneyList() {
      this.money = [];
      this.money.push(new Money(1, 5600, "Car payment", "true", "2015-12-11T17:30:00.000Z", 1));
      this.money.push(new Money(2, 1240, "Friday Night", "true", "2015-12-13T13:25:00.000Z", 1));
      this.money.push(new Money(3, 12840, "Wages", "false", "2015-12-15T08:00:00.000Z", 1));
      this.money.push(new Money(4, 940, "Friday Night", "true", "2015-12-13T13:25:00.000Z", 3));
      this.money.push(new Money(5, 760, "Christmas tree", "true", "2015-12-15T08:00:00.000Z", 4));
      return this;
    }

    MoneyList.prototype.addMoney = function(moneydata) {
      var mny_array_id;
      mny_array_id = this.money.push(new Money(this.getLastId() + 1, moneydata.amount, moneydata.description, moneydata.spending, moneydata.date));
      return this.money[mny_array_id - 1];
    };

    MoneyList.prototype.getAllMoney = function() {
      return this.money;
    };

    MoneyList.prototype.getMoneyByUser = function(userId) {
      return this.money.filter(function(item) {
        return item.userId === parseInt(userId);
      });
    };

    MoneyList.prototype.getLastId = function() {
      this.sort();
      return this.money[this.money.length - 1].id_user;
    };

    MoneyList.prototype.findById = function(id) {
      var j, len, money, ref;
      ref = this.money;
      for (j = 0, len = ref.length; j < len; j++) {
        money = ref[j];
        if (money.moneyId === parseInt(id)) {
          return money;
        }
      }
      return false;
    };

    MoneyList.prototype.removeMoney = function(money) {
      var i;
      i = this.money.indexOf(money);
      return this.money.splice(i, 1);
    };

    MoneyList.prototype.sort = function() {
      return this.money.sort(function(a, b) {
        if (a.id_user < b.id_user) {
          return -1;
        } else if (a.id_user > b.id_user) {
          return 1;
        } else {
          return 0;
        }
      });
    };

    return MoneyList;

  })();

  module.exports = MoneyList;

}).call(this);
