// Generated by CoffeeScript 1.9.3
(function() {
  var Money, MoneyList, User, UserList, app, bodyParser, cors, express, moneyList, port, requireUser, router, users;

  Money = (function() {
    function Money(moneyId, amount, description, spending, date, userId1) {
      this.moneyId = moneyId;
      this.amount = amount;
      this.description = description;
      this.spending = spending;
      this.date = date;
      this.userId = userId1;
    }

    return Money;

  })();

  module.exports = Money;

  Money = require("./Money");

  MoneyList = (function() {
    function MoneyList() {
      this.money = [];
      this.money.push(new Money(1, 5600, "Car payment", "true", "2015-12-11T17:30:00.000Z", 1));
      this.money.push(new Money(2, 1240, "Friday Night", "true", "2015-12-13T13:25:00.000Z", 1));
      this.money.push(new Money(3, 12840, "Wages", "false", "2015-12-15T08:00:00.000Z", 1));
      this.money.push(new Money(4, 940, "Friday Night", "true", "2015-12-13T13:25:00.000Z", 3));
      this.money.push(new Money(5, 760, "Christmas tree", "true", "2015-12-15T08:00:00.000Z", 4));
      return this;
    }

    MoneyList.prototype.addMoney = function(moneydata) {
      var mny_array_id;
      mny_array_id = this.money.push(new Money(this.getLastId() + 1, moneydata.amount, moneydata.description, moneydata.spending, moneydata.date));
      return this.money[mny_array_id - 1];
    };

    MoneyList.prototype.getAllMoney = function() {
      return this.money;
    };

    MoneyList.prototype.getMoneyByUser = function(userId) {
      return this.money.filter(function(item) {
        return item.userId === parseInt(userId);
      });
    };

    MoneyList.prototype.getLastId = function() {
      this.sort();
      return this.money[this.money.length - 1].id_user;
    };

    MoneyList.prototype.findById = function(id) {
      var j, len, money, ref;
      ref = this.money;
      for (j = 0, len = ref.length; j < len; j++) {
        money = ref[j];
        if (money.moneyId === parseInt(id)) {
          return money;
        }
      }
      return false;
    };

    MoneyList.prototype.removeMoney = function(money) {
      var i;
      i = this.money.indexOf(money);
      return this.money.splice(i, 1);
    };

    MoneyList.prototype.sort = function() {
      return this.money.sort(function(a, b) {
        if (a.id_user < b.id_user) {
          return -1;
        } else if (a.id_user > b.id_user) {
          return 1;
        } else {
          return 0;
        }
      });
    };

    return MoneyList;

  })();

  module.exports = MoneyList;

  User = (function() {
    function User(id_user, name, lastname, birthday, gender) {
      this.id_user = id_user;
      this.name = name;
      this.lastname = lastname;
      this.birthday = birthday;
      this.gender = gender;
      this.money = [];
    }

    User.prototype.getMoney = function(moneyList) {
      return this.money = moneyList.getMoneyByUser(this.id_user);
    };

    return User;

  })();

  module.exports = User;

  User = require("./User");

  UserList = (function() {
    function UserList() {
      this.users = [];
      this.users.push(new User(1, "Antonín", "Neumann", "1989-09-07T00:00:00.000Z", "male"));
      this.users.push(new User(2, "Iveta", "Dobrá", "1992-02-06T00:00:00.000Z", "female"));
      this.users.push(new User(3, "Jan", "Novák", "1991-07-13T00:00:00.000Z", "male"));
      this.users.push(new User(4, "Jonh", "Doe", "1999-09-09T00:00:00.000Z", "male"));
      return this;
    }

    UserList.prototype.addUser = function(userdata) {
      var usr_array_id;
      usr_array_id = this.users.push(new User(this.getLastId() + 1, userdata.name, userdata.lastname, userdata.birthday, userdata.gender));
      return this.users[usr_array_id - 1];
    };

    UserList.prototype.getAllUsers = function() {
      return this.users;
    };

    UserList.prototype.getMoney = function(moneyList) {
      var j, len, ref, results, user;
      ref = this.users;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        user = ref[j];
        results.push(user.getMoney(moneyList));
      }
      return results;
    };

    UserList.prototype.getLastId = function() {
      this.sort();
      return this.users[this.users.length - 1].id_user;
    };

    UserList.prototype.findById = function(id) {
      var j, len, ref, user;
      ref = this.users;
      for (j = 0, len = ref.length; j < len; j++) {
        user = ref[j];
        if (user.id_user === parseInt(id)) {
          return user;
        }
      }
      return false;
    };

    UserList.prototype.removeUser = function(user) {
      var i;
      i = this.users.indexOf(user);
      return this.users.splice(i, 1);
    };

    UserList.prototype.sort = function() {
      return this.users.sort(function(a, b) {
        if (a.id_user < b.id_user) {
          return -1;
        } else if (a.id_user > b.id_user) {
          return 1;
        } else {
          return 0;
        }
      });
    };

    return UserList;

  })();

  module.exports = UserList;

  express = require('express');

  app = express();

  bodyParser = require('body-parser');

  cors = require('cors');

  User = requireUser = require('./model/User');

  UserList = require('./model/UserList');

  Money = require('./model/Money');

  MoneyList = require('./model/MoneyList');

  app.use(bodyParser.urlencoded({
    extended: true
  }));

  app.use(bodyParser.json());

  port = process.env.PORT || 8080;

  router = express.Router();

  users = new UserList();

  moneyList = new MoneyList();

  router.use(function(req, res, next) {
    return next();
  });

  app.use(cors());

  app.use(function(req, res, next) {
    res.header("Access-Control-Allow-Credentials", "true");
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept, Content-length");
    res.header("Access-Control-Allow-Methods", "GET, POST, PUT, DELETE");
    return next();
  });

  router.get('/', function(req, res) {
    return res.json({
      message: 'hooray! welcome to our api!'
    });
  });

  router.route('/test').get(function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  }).post(function(req, res) {
    return res.status(201).json({
      responese: "OK"
    });
  }).put(function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  })["delete"](function(req, res) {
    return res.status(200).json({
      responese: "OK"
    });
  });

  router.route('/users').post(function(req, res) {
    var newUser;
    newUser = users.addUser(req.body);
    if (newUser === false) {
      return res.status(400).json({
        message: 'Error: User wasn\'t created!'
      });
    } else {
      return res.status(201).json(newUser);
    }
  }).put(function(req, res) {
    var key, ref, usr, value;
    usr = users.findById(parseInt(req.body.id_user));
    ref = req.body;
    for (key in ref) {
      value = ref[key];
      usr[key] = value;
    }
    return res.status(200).json();
  }).get(function(req, res) {
    var fullUserList, j, len, user;
    users.getMoney(moneyList);
    fullUserList = users.getAllUsers();
    if (req.query.gender) {
      fullUserList = fullUserList.filter(function(item) {
        return item.gender === req.query.gender;
      });
    }
    if (req.query.count) {
      fullUserList = fullUserList.slice(0, Math.min(fullUserList.length, parseInt(req.query.count)));
    }
    if (req.query.spending) {
      for (j = 0, len = fullUserList.length; j < len; j++) {
        user = fullUserList[j];
        user.money = user.money.filter(function(item) {
          return item.spending === req.query.spending;
        });
      }
    }
    return res.json(fullUserList);
  });

  router.route('/users/:user_id').get(function(req, res) {
    var usr;
    usr = users.findById(req.params.user_id);
    if (!req.query.money || req.query.money !== 'true') {
      usr.money = null;
    }
    if (usr === false) {
      return res.status(404).json();
    } else {
      return res.json(usr);
    }
  })["delete"](function(req, res) {
    var removed, tmpUser;
    tmpUser = users.findById(req.params.user_id);
    if (!tmpUser) {
      res.status(404).json();
    }
    removed = users.removeUser(tmpUser);
    return res.status(200).json();
  });

  router.route('/money').post(function(req, res) {
    var newMoney;
    newMoney = moneyList.addMoney(req.body);
    if (newMoney === false) {
      return res.status(400).json({
        message: 'Error: Money wasn\'t created!'
      });
    } else {
      return res.status(201).json(newMoney);
    }
  }).put(function(req, res) {
    return res.status(200).json();
  }).get(function(req, res) {
    var fullMoneyList, j, len, user;
    fullMoneyList = moneyList.getAllMoney();
    if (req.query.userId) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.userId === parseInt(req.query.userId);
      });
    }
    if (req.query.lessThan) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.amount < parseInt(req.query.lessThan);
      });
    }
    if (req.query.moreThan) {
      fullMoneyList = fullMoneyList.filter(function(item) {
        return item.amount > parseInt(req.query.moreThan);
      });
    }
    if (req.query.count) {
      fullMoneyList = fullMoneyList.slice(0, Math.min(fullMoneyList.length, parseInt(req.query.count)));
    }
    if (req.query.spending) {
      for (j = 0, len = fullMoneyList.length; j < len; j++) {
        user = fullMoneyList[j];
        user.money = user.money.filter(function(item) {
          return item.spending === req.query.spending;
        });
      }
    }
    return res.json(fullMoneyList);
  });

  router.route('/money/:money_id').get(function(req, res) {
    var usr;
    usr = moneyList.findById(req.params.money_id);
    if (usr === false) {
      return res.status(404).json();
    } else {
      return res.json(usr);
    }
  })["delete"](function(req, res) {
    var removed, tmpMoney;
    tmpMoney = moneyList.findById(req.params.money_id);
    if (!tmpMoney) {
      res.status(404).json();
    }
    removed = moneyList.removeMoney(tmpMoney);
    return res.status(200).json();
  });

  app.use('/api', router);

  app.listen(port);

}).call(this);
