<?php
ini_set('memory_limit','512M');
session_id('session-zcu-kiv-vsp-api');
session_start();
require 'Slim/Slim.php';
\Slim\Slim::registerAutoloader();
$app = new \Slim\Slim();

require_once('model/User.php');
require_once('model/UserList.php');
require_once('model/Money.php');
require_once('model/MoneyList.php');

header("Access-Control-Allow-Credentials: true");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, Content-length");
header("Access-Control-Allow-Methods: GET, POST, PUT, DELETE, OPTIONS");
header("Content-type: application/json; charset=utf-8");
/**
 * Step 3: Define the Slim application routes
 *
 * Here we define several Slim application routes that respond
 * to appropriate HTTP request methods. In this example, the second
 * argument for `Slim::get`, `Slim::post`, `Slim::put`, `Slim::patch`, and `Slim::delete`
 * is an anonymous function.
 */
register_shutdown_function('save_session');
function save_session(){
    $_SESSION['userList'] = serialize($GLOBALS['userList']);
    $_SESSION['moneyList'] = serialize($GLOBALS['moneyList']);
}

if(isset($_SESSION['userList'])){
    $GLOBALS['userList'] = unserialize($_SESSION['userList']);
}else {
    $GLOBALS['userList'] = new UserList();
}
if(isset($_SESSION['userList'])){
    $GLOBALS['moneyList'] = unserialize($_SESSION['moneyList']);
}else {
    $GLOBALS['moneyList'] = new MoneyList();
}



$allGetVars = $app->request->get();
$allPostVars = $app->request->post();
$allPutVars = $app->request->put();
$requestBody = $app->request->getBody();
   
$app->group('/api', function () use ($app) {

    //match all OPTIONS request a set headers
    $app->options('/(:name+)', function() use ($app) {});
    
    
    $app->map('/test', function() {
        if(!empty($GLOBALS['allGetVars'])){
            //GET variables
        }   
        $result = json_encode(array("response" => "OK"));
        http_response_code(200);
        echo($result);
        exit();
    })->via('GET', 'PUT', 'DELETE');
    $app->post('/test', function() {
        $result = json_encode(array("response" => "OK"));
        http_response_code(201);
        echo($result);
        exit();
    });


    // GET route
    $app->get('/users',
        function () {
            $data = $GLOBALS['userList']->getAllUsers();
            if(!empty($GLOBALS['allGetVars'])){
                if(isset($GLOBALS['allGetVars']['gender'])){
                    foreach ($data as $key => $value) {
                        if($value->gender != $GLOBALS['allGetVars']['gender']){
                            array_splice($data, $key, 1);
                        }
                    }
                }
            } 
            $result = json_encode($data);
            echo($result);
            exit();
        }
    );

    // POST route
    $app->post('/users',
        function () {
            if(empty($GLOBALS['requestBody'])){
                http_response_code(400);exit();
            }else {
                $newUser = $GLOBALS['userList']->addUser(json_decode($GLOBALS['requestBody']));
                echo(json_encode($newUser));
                exit;
            }
        }
    );

    // PUT route
    $app->put('/users',
        function () {
            echo(json_encode(array("msg" => "/users PUT")));
            exit;
        }
    );

    $app->get('/users:user_id',
        function () {
            echo(json_encode(array("msg" => "/users:user_id GET")));
            exit;
        }
    );
    // DELETE route
    $app->delete('/users:user_id',
        function () {
            echo(json_encode(array("msg" => "/users:user_id DELETE")));
            exit;
        }
    );
    
    
    /*
     * MONEY routes
     */
    // GET route
    $app->get('/money',
        function () {
            $data = $GLOBALS['moneyList']->getAllMoney();

            $result = json_encode($data);
            echo($result);
            exit();
        }
    );

    // POST route
    $app->post('/money',
        function () {
            echo(json_encode(array("msg" => "/money POST")));
            exit;
        }
    );

    // PUT route
    $app->put('/money',
        function () {
            echo(json_encode(array("msg" => "/money PUT")));
            exit;
        }
    );

    $app->get('/money:money_id',
        function () {
            echo(json_encode(array("msg" => "/money:money_id GET")));
            exit;
        }
    );
    // DELETE route
    $app->delete('/money:money_id',
        function () {
            echo(json_encode(array("msg" => "/money:money_id DELETE")));
            exit;
        }
    );  
});
$app->run();
